<%@ page import="org.jetbrains.teamcity.docker.DockerSupportBuildFeature" %>
<%@ page import="org.jetbrains.teamcity.docker.connectors.RegistryConnectionProvider" %>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="bs" tagdir="/WEB-INF/tags" %>
<%@ taglib prefix="intprop" uri="/WEB-INF/functions/intprop" %>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<jsp:useBean id="propertiesBean" scope="request" type="jetbrains.buildServer.controllers.BasePropertiesBean"/>
<jsp:useBean id="buildForm"  scope="request" type="jetbrains.buildServer.controllers.admin.projects.EditableBuildTypeSettingsForm"/>
<jsp:useBean id="buildFeature"  scope="request" type="org.jetbrains.teamcity.docker.DockerSupportBuildFeature "/>
<tr>
  <td colspan="2">
    <em>Docker Support tracks pushed images and adds a dedicated tab with information about them</em> <bs:help file="Docker+Support"/>
  </td>
</tr>
<tr>
  <td colspan="2">
    <c:set var="cleanupProp" value="<%= DockerSupportBuildFeature.CLEANUP_PUSHED_PROP %>"/>
    <props:checkboxProperty name="${cleanupProp}"/>&nbsp;<label for="${cleanupProp}">On clean-up, delete images pushed to a registry during the build</label>
    <span class="error" id="error_${cleanupProp}"></span>
  </td>
</tr>
<tr>
  <td colspan="2">
    <c:set var="loginProp" value="<%= DockerSupportBuildFeature.LOGIN_2_REGISTRY_PROP %>"/>
    <c:set var="initialRegistryVal" value="${propertiesBean.properties['login2registry']}"/>
    <div style="float:left">
      <input type="checkbox" id="loginCheckbox" name="prop:loginCheckbox"/>&nbsp;<label for="loginCheckbox">Log in to the Docker registry before the build:</label>&nbsp;
    </div>
    <div style="float:left">
      <props:selectProperty name="${loginProp}">
        <props:option value="">No connection provided</props:option>
        <c:forEach var="connType" items="${buildFeature.registryConnectionTypes()}">
          <c:forEach var="conn" items="${buildFeature.OAuthConnectionsManager.getAvailableConnectionsOfType(buildForm.project, connType)}">
            <props:option value="${conn.id}"
            ><c:out value="${conn.connectionDisplayName}"/><c:if test="${fn:startsWith(conn.parameters['repositoryUrl'], 'http://')}"
            > (insecure)</c:if></props:option>
          </c:forEach>
        </c:forEach>
      </props:selectProperty>
      <c:set var="connectorType" value="<%=RegistryConnectionProvider.TYPE%>"/>
      <span class="smallNote">Add credentials via the <a href="<c:url value='/admin/editProject.html?projectId=${buildForm.project.externalId}&tab=oauthConnections#addDialog=${connectorType}'/>" target="_blank">Project Connections</a> page</span>
      <props:hiddenProperty name="invalidRegistry" value=""/>
      <script>

        function showHideWarn(){
          var text = $j('#${loginProp} option:selected').text();
          if (text.endsWith('(insecure)')){
            $j('#warn_${loginProp}').show();
          } else {
            $j('#warn_${loginProp}').hide();
          }
          if ($j('#invalidRegistry').val()==='true' && $j('#${loginProp}').val()!=='${initialRegistryVal}'){
            $j('#invalidRegistry').val('');
            $j('#${loginProp} option[value="${initialRegistryVal}"]').remove();
            $j('#error_${loginProp}').text('');
          }
        }

        $j(document).ready(function(){
          $j('#${loginProp}').on('change', showHideWarn);
          showHideWarn();
          $j('#loginCheckbox').on('change', function(){
            if (this.checked){
              $j('#${loginProp}').prop('disabled', false);
            } else {
              $j('#${loginProp}').prop('disabled', true);
              $j('#${loginProp}').val('');
            }
          });
          if ('${initialRegistryVal}' !== '') {
            $j('#loginCheckbox').attr('checked', true);
            if (!$j('#${loginProp}').val()) {
              $j('#${loginProp}').append($j('<option>', {
                value: '${initialRegistryVal}',
                text: '<Non-existing connection>'
              }));
              $j('#invalidRegistry').val('true');
              $j('#${loginProp}').val('${initialRegistryVal}');
              $j('#error_${loginProp}').text('Please choose valid connection');
            }
          } else
            $j('#${loginProp}').prop('disabled', true);
        });

      </script>
      <span class="error" id="error_${loginProp}"></span>
    </div>
  </td>
</tr>
<tr id="warn_${loginProp}" class="noBorder" style="display: none;">
  <td colspan="2">
    <div class="icon_before icon16 attentionComment">
      The selected Docker registry is <strong>insecure</strong>. To use the registry, add it to the Docker configuration on all compatible agents.
    </div>
  </td>
</tr>



