<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="bs" tagdir="/WEB-INF/tags" %>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<jsp:useBean id="propertiesBean" scope="request" type="jetbrains.buildServer.controllers.BasePropertiesBean"/>
<jsp:useBean id="form" class="org.jetbrains.teamcity.docker.FormBean"/>
<style type="text/css">
  .posRel.docker {
    padding-right: 0 !important;
  }

  .posRel .posRel {
    padding-right: 40px !important;
  }
</style>
<script>
  BS.DockerBuild = {
    initPage: function () {
      this.onDockerSourceUpdate();
    },

    onDockerSourceUpdate: function () {
      var source = $j('#chooser').val();
      if (source === 'URL') {
        $j('#pathRow').css('display', 'none');
        $j('#contextRow').css('display', 'none');
        $j('#urlRow').css('display', 'table-row');
        $j('#contentRow').css('display', 'none');
        $j('#path').val('');
        $j('#dockerfileContent').html('');
        $j('#dockerContextFolder').val('');
      } else if (source === 'CONTENT') {
        $j('#pathRow').css('display', 'none');
        $j('#contextRow').css('display', 'none');
        $j('#urlRow').css('display', 'none');
        $j('#contentRow').css('display', 'table-row');
        $j('#path').val('');
        $j('#url').val('');
        $j('#dockerContextFolder').val('');
        var rows = Math.max(($j('#dockerfileContent').html().match(/\r?\n/g) || '').length + 1, 3);
        $j('#dockerfileContent').attr('rows', rows);
        $j('#dockerfileContent').css('height', "");
      } else {
        // source == 'FILE' or undefined
        $j('#pathRow').css('display', 'table-row');
        $j('#contextRow').css('display', 'table-row');
        $j('#urlRow').css('display', 'none');
        $j('#contentRow').css('display', 'none');
        $j('#url').val('');
        $j('#dockerfileContent').html('');
      }
      var l = $j('.posRel.docker .posRel').length;
      if (l === 0){
        $j('.posRel.docker').removeClass('docker');
      }
    }

  }
</script>
<l:settingsGroup title="Docker Build Parameters">
  <tr>
    <th>
      <label for="chooser">Dockerfile source: <bs:help file="Docker build"/></label>
    </th>
    <td>
      <props:selectProperty id="chooser" name="${form.dockerFileSource}" onchange="BS.DockerBuild.onDockerSourceUpdate()">
        <props:option value="PATH">File</props:option>
        <props:option value="URL">URL</props:option>
        <props:option value="CONTENT">File content</props:option>
      </props:selectProperty>
    </td>
  </tr>
  <tr id="pathRow" style="display: none;">
    <th>
      <label for="path">Path to file:
        <span class="mandatoryAsterix" title="Mandatory field">*</span>
      </label>
    </th>
    <td>
      <div class="posRel docker">
      <props:textProperty id="path" name="${form.dockerfileLocation}" className="longField"/>
        <bs:vcsTree fieldId="path"/>
      </div>
      <span class="error" id="error_${form.dockerfileLocation}"></span>
      <span class="smallNote">The specified path should be relative to the checkout directory.</span>
    </td>
  </tr>
  <tr id="urlRow" style="display: none;">
    <th>
      <label for="url">URL to file:
        <span class="mandatoryAsterix" title="Mandatory field">*</span>
      </label>
    </th>
    <td>
      <props:textProperty id="url" name="${form.dockerfileUrl}" className="longField"/>
      <span class="error" id="error_${form.dockerfileUrl}"></span>
    </td>
  </tr>
  <tr id="contentRow" style="display: none;">
    <th>
      <label for="dockerfileContent">Content:
        <span class="mandatoryAsterix" title="Mandatory field">*</span>
      </label>
    </th>
    <td>
      <props:textProperty id="dockerfileContent" name="${form.dockerfileContent}" className="longField" expandable="true"/>
      <span class="error" id="error_${form.dockerfileContent}"></span>
    </td>
  </tr>
  <tr id="contextRow" style="display: none;">
    <th>
      <label for="${form.dockerContextFolder}">Context folder:</label>
    </th>
    <td>
      <div class="posRel docker">
        <props:textProperty id="dockerContextFolder" name="${form.dockerContextFolder}" className="longField"/>
        <bs:vcsTree fieldId="dockerContextFolder"/>
      </div>
      <span class="smallNote">If blank, the folder containing the Dockerfile will be used.</span>
    </td>
  </tr>
  <tr>
    <th>
      <label for="${form.namesAndTags}">Name:tag(s)</label>
    </th>
    <td>
      <props:textProperty name="${form.namesAndTags}" className="longField" expandable="true"/>
      <span class="smallNote">Newline-separated list of the image name:tag(s).</span>
    </td>
  </tr>
  <tr>
    <th>
      <label for="${form.commandArguments}">Additional arguments for 'build' command:</label>
    </th>
    <td>
      <props:textProperty name="${form.commandArguments}" className="longField" expandable="true"/>
      <span class="smallNote">Additional arguments that will be passed to the 'build' command.</span>
    </td>
  </tr>
</l:settingsGroup>

<script>
  BS.DockerBuild.initPage();
</script>
