<%@ page import="org.jetbrains.teamcity.docker.DockerWrapperConstants" %>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="bs" tagdir="/WEB-INF/tags" %>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<jsp:useBean id="propertiesBean" scope="request" type="jetbrains.buildServer.controllers.BasePropertiesBean"/>
<jsp:useBean id="form" class="org.jetbrains.teamcity.docker.FormBean"/>

<script>
    BS.Docker = {
      initPage: function() {

      },

      onDockerImageUpdate: function(value) {
        var el = $j('.js-dockerExtra');
        if (value) {
          if (!el.hasClass('hidden')) return;
          el.removeClass('hidden');
          this._scaleDown(el, 150);
          setTimeout(function() {
            BS.MultilineProperties.updateVisible();
          }, 150);
        }
        else {
          el.addClass('hidden');
        }
      },

      _scaleDown: function(el, msecs) {
        if (typeof el[0].style.transform !== 'undefined') {
          el.css('transformOrigin', '0 0');

          var start = 0;
          function step(timestamp) {
            if (!start) {
              start = timestamp;
            }

            var progress = (timestamp - start)/msecs;
            if (progress <= 1) {
              el.css("transform", 'scaleY(' + progress + ')');
              window.requestAnimationFrame(step);
            }
            else {
              el.css("transform", 'none');
            }
          }

          window.requestAnimationFrame(step);
        }
      }

    }
</script>
<style>
    .runnerFormTable td span.smallNote.pullImage {
        display: inline-block;
        margin-left: 5px;
    }
    .smallNote.pullImage code {
        font-size: 12px;
    }

</style>
<l:settingsGroup title="Docker Settings" className="advancedSetting">

    <!--
    <span class="smallNote" style="display: inline-block"> Docker version is available via agent configuration parameter 'docker', like 1.13.0-49bf474</span>
    -->


    <c:set var="propName" value="<%= DockerWrapperConstants.IMAGE %>"/>
    <c:set var="dockerWrapperEnabled" value="${not empty propertiesBean.properties[propName]}"/>
    <tr class="advancedSetting">
        <th>
            <label for="${propName}">Run step within Docker container: <bs:help file="Docker Wrapper"/></label>
        </th>
        <td>
            <props:textProperty name="${propName}" className="js-docker-property longField" onchange="BS.Docker.onDockerImageUpdate(this.value)" onkeyup="BS.Docker.onDockerImageUpdate(this.value)"/>
            <span class="smallNote">E.g. ruby:2.4. TeamCity will start a container from the specified image and will try to run this build step within this container.
                <bs:help file="Docker Wrapper"/></span>

        </td>
    </tr>


    <tr class="advancedSetting ${dockerWrapperEnabled ? '' : 'hidden'} js-dockerExtra" >
        <c:set var="propName" value="<%= DockerWrapperConstants.PULL_ENABLED %>"/>
        <th>
            <label for="${propName}">Pull image explicitly:</label>
        </th>
        <td>
            <props:checkboxProperty name="${propName}"/>
            <span class="smallNote pullImage">
                If enabled, <code>docker pull &lt;imageName&gt;</code> will be run before <code>docker run</code> command.
            </span>
        </td>
    </tr>

    
    <tr class="advancedSetting ${dockerWrapperEnabled ? '' : 'hidden'} js-dockerExtra" >
        <c:set var="propName" value="<%= DockerWrapperConstants.RUN_PARAMETERS %>"/>
        <th>
            <label for="${propName}">Additional docker run arguments:</label>
        </th>
        <td>
            <props:textarea name="prop:${propName}" textAreaName="prop:${propName}" value="${propertiesBean.properties[propName]}"
                            linkTitle="Edit arguments" cols="70" rows="3" expanded="${not empty propertiesBean.properties[propName]}" className="longField"/>
            <span class="smallNote">
                Default argument is <code>--rm</code>, you can specify additional ones.
            </span>
        </td>
    </tr>

</l:settingsGroup>

<script>
    BS.Docker.initPage();
</script>
