<%@ page import="org.jetbrains.teamcity.docker.RegistryWebConstants" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ include file="/include-internal.jsp"%>
<%@ taglib prefix="intprop" uri="/WEB-INF/functions/intprop" %>

<bs:linkScript>
  /js/bs/testConnection.js
</bs:linkScript>
<script>
  BS.OAuthConnectionDialog.submitTestConnection = function () {
    var that = this;
    BS.PasswordFormSaver.save(this, '<c:url value="/repo/registry-test-connection.html"/>', OO.extend(BS.ErrorsAwareListener, {
      onFailedTestConnectionError: function (elem) {
        var text = "";
        if (elem.firstChild) {
          text = elem.firstChild.nodeValue;
        }
        BS.TestConnectionDialog.show(false, text, $('testConnectionButton'));
      },
      onCompleteSave: function (form, responseXML) {
        var err = BS.XMLResponse.processErrors(responseXML, this, form.propertiesErrorsHandler);
        BS.ErrorsAwareListener.onCompleteSave(form, responseXML, err);
        if (!err) {
          this.onSuccessfulSave(responseXML);
        }
      },
      onSuccessfulSave: function (responseXML) {
        that.enable();
        var additionalInfo = "";
        var testConnectionResultNodes = responseXML.documentElement.getElementsByTagName("testConnectionResult");
        if (testConnectionResultNodes && testConnectionResultNodes.length > 0) {
          var testConnectionResult = testConnectionResultNodes.item(0);
          if (testConnectionResult.firstChild) {
            additionalInfo = testConnectionResult.firstChild.nodeValue;
          }
        }
        BS.TestConnectionDialog.show(true, additionalInfo, $('testConnectionButton'));
      }
    }));
    return false;
  };

  var afterClose = BS.OAuthConnectionDialog.afterClose;
  BS.OAuthConnectionDialog.afterClose = function () {
    $j('#OAuthConnectionDialog .testConnectionButton').remove();
    afterClose()
  }
</script>
<tr>
  <td><label for="displayName">Display name:</label><l:star/></td>
  <td>
    <props:textProperty name="displayName" className="longField" style="width: 20em;"/>
    <span class="smallNote">Provide some name to distinguish this connection from others.</span>
    <span class="error" id="error_displayName"></span>
  </td>
</tr>
<tr>
  <c:set var="addressParam" value="<%=RegistryWebConstants.ADDRESS_PARAM%>"/>
  <td><label for="${addressParam}">Registry address:</label><l:star/> <bs:help file="Configuring+Connections+to+Docker#ConfiguringConnectionstoDocker-RegistryAddressFormat"/></td>
  <td>
    <props:textProperty name="${addressParam}" style="width: 20em;"/>
    <span class="smallNote">Format: [http(s)://]hostname[:port], by default https:// is used</span>
    <span class="error" id="error_${addressParam}"></span>
  </td>
</tr>
<tr>
  <c:set var="usernameParam" value="<%=RegistryWebConstants.USERNAME_PARAM%>"/>
  <td><label for="${usernameParam}">Username:</label></td>
  <td>
    <props:textProperty name="${usernameParam}" style="width: 15em;"/>
    <span class="smallNote">Leave blank for anonymous access</span>
  </td>
</tr>
<tr>
  <c:set var="passwordParam" value="<%=RegistryWebConstants.PASSWORD_PARAM%>"/>
  <td><label for="${passwordParam}">Password:</label></td>
  <td>
    <props:passwordProperty name="${passwordParam}" style="width: 15em;"/>
    <span class="smallNote">Leave blank for anonymous access</span>
  </td>
</tr>
<forms:submit id="testConnectionButton" type="button" label="Test Connection" className="testConnectionButton"
              onclick="return BS.OAuthConnectionDialog.submitTestConnection();"/>
<bs:dialog dialogId="testConnectionDialog" title="Test Connection" closeCommand="BS.TestConnectionDialog.close();"
           closeAttrs="showdiscardchangesmessage='false'">
  <div id="testConnectionStatus"></div>
  <div id="testConnectionDetails" class="mono"></div>
</bs:dialog>
<script>
  $j("#testConnectionButton").insertAfter($j('#OAuthConnectionDialog .popupSaveButtonsBlock input.submitButton')[0])
</script>
